#ifndef DS1339_H
#define DS1339_H

#include <stdint.h>

#define DS1339_I2C_ADDRESS 0x68 

class DS1339 
{
public:
   enum 
   {
      TC_NO_CHARGE = 0x00,
      TC_250       = 0xa5,
      TC_DIODE_250 = 0xa9,
      TC_2K        = 0xa6,
      TC_DIODE_2K  = 0xaa,
      TC_4K        = 0xa7,
      TC_DIODE_4K  = 0xab
   };

   DS1339()
   {
   };

   void EnableTrickleCharge(uint8_t flags);

   /**********************************************************************/
   /*   Convert a byte from binary to bcd                                */
   /**********************************************************************/
   uint8_t decToBcd(uint8_t val);
   /**********************************************************************/
   /*   Convert bcd do a byte of binary                                  */
   /**********************************************************************/
   uint8_t bcdToDec(uint8_t val);
   void readTime(uint8_t *sec,
                 uint8_t *min,
                 uint8_t *hour,
                 uint8_t *day,
                 uint8_t *dow,
                 uint8_t *month,
                 uint16_t *year);

   void setTime(uint8_t sec,
                uint8_t min,
                uint8_t hour,
                uint8_t day,
                uint8_t dow,
                uint8_t month,
                uint16_t year);
protected:
private:
};

#endif
