/*
  switch.h - Kitschy Nixie Neon Clock

  Copyright (c) 2017 Joe Croft <croftj@gmail.com>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA

  $Id: //depot/kitchenclock/code/switch.h#3 $
*/

#ifndef SWITCH_H
#define  SWITCH_H

#include <inttypes.h>

enum 
{
   SW1_ON,
   SW1_SHORT,
   SW1_LONG,
   SW1_OFF,

   SW2_ON,
   SW2_SHORT,
   SW2_LONG,
   SW2_OFF,

   SW3_ON,
   SW3_SHORT,
   SW3_LONG,
   SW3_OFF,

   SW4_ON,
   SW4_SHORT,
   SW4_LONG,
   SW4_OFF,

   SWITCH_STATES = SW2_ON
};

enum 
{
   SWITCH1,
   SWITCH2,
   SWITCH3,
   SWITCH4,
   SWITCH_COUNT
};

class Switch 
{
public:
   Switch();
   void update();
   uint8_t check();
   void setAutoRepeat(uint8_t flag);
   void setAutoRepeat(uint8_t sw, uint8_t flag);
   void printTimes();
   void Enable()
   {
      m_enabled = true;
   }

   void Disable()
   {
      m_enabled = false;
   }

protected:
private:
   uint8_t  m_swCount[SWITCH_COUNT];
   uint32_t m_swTime[SWITCH_COUNT];
   uint8_t  m_swState[SWITCH_COUNT];
   bool     m_autoRepeat[SWITCH_COUNT];
   bool     m_enabled;
   uint8_t     m_sw1Count;
   uint8_t     m_sw2Count;

   static uint16_t SW_ON_MIN;
   static uint16_t SW_ON_TRIGGER;
   static uint16_t SW_ON_MAX;
   static uint16_t SW_SHORT_MIN;
   static uint16_t SW_SHORT_MAX;
   static uint16_t SW_LONG_MIN;
   static uint16_t SW_LONG_MAX;
};

extern Switch switches;
#endif

